using JiShe.CollectBus.Common.Enums;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.Common.Helpers;
using JiShe.CollectBus.IotSystems.Ammeters;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol.T37612012.AnalysisData;
using JiShe.CollectBus.Protocol.T37612012.Appendix;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;

namespace JiShe.CollectBus.Protocol.T37612012.AFN_0CH
{
    /// <summary>
    /// 5.12.2.4.105 F149：上月（上一结算日）正向有功最大需量及发生时间（总、费率 1～M）
    /// </summary>
    public class AFN12_F149_Analysis : IAnalysisStrategy<TB3761>
    {

        private readonly ILogger<AFN12_F149_Analysis> _logger;
        private readonly AnalysisStrategyContext _analysisStrategyContext;
        private readonly DataStorage _dataStorage;
        public AFN12_F149_Analysis(ILogger<AFN12_F149_Analysis> logger, AnalysisStrategyContext analysisStrategyContext, DataStorage dataStorage)
        {
            _logger = logger;
            _analysisStrategyContext = analysisStrategyContext;
            _dataStorage= dataStorage;
        }


        public async Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.UnitData?.HexMessageList);
                List<string> datas =  await AnalysisDataUnit(input.UnitData.HexMessageList);
                string dataType = $"{input.AFN_FC.AFN.HexToDecStr().PadLeft(2, '0')}_{input.DT.Fn}";

                AnalysisBaseDto<decimal> data = GenerateFinalResult(datas, dataType,"上月（上一结算日）正向有功最大需量及发生时间");
                // 查询电表信息
                AmmeterInfo ammeterInfo = await _dataStorage.GetMeterInfoAsync(data.MeterType.ToString(), "15");
                if (ammeterInfo != null)
                {
                    data.ProjectId = ammeterInfo.ProjectID;
                    data.MeterId = ammeterInfo.MeterId;
                    data.DatabaseBusiID=ammeterInfo.DatabaseBusiID;
                    data.MeterAddress= ammeterInfo.AmmerterAddress;
                }
                UnitDataAnalysis<AnalysisBaseDto<decimal>> unitDataAnalysis = new UnitDataAnalysis<AnalysisBaseDto<decimal>>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    MSA=input.A.A3!.D1_D7!,
                    PSEQ=input.SEQ.PSEQ,
                    Data = data,
                    HexMessage=input.BaseHexMessage.HexMessageString,
                    MessageId=input.MessageId,
                    TimeDensity=1,
                    DensityUnit = DensityUnit.Month,
                    ReceivedTime = input.ReceivedTime
                };
                await _dataStorage.SaveDataToIotDbAsync<decimal>(unitDataAnalysis);
                result?.Invoke(unitDataAnalysis);
                return await Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"0C_149解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");

            }
            return await Task.FromResult(false);

        }
        private async Task<List<string>> AnalysisDataUnit(List<string> hexMessageList)
        {
            List<string> values = new List<string>();
            values.Add(hexMessageList.GetReadTime(4, 5));
            int ratingCount = hexMessageList.GetRatingCount(9, 1);
            values.Add(ratingCount.ToString());
            for (int i = 0; i < ratingCount + 1; i++)
            {
                var arr = hexMessageList.GetRange(10 + i * 7, 3);
                var errorCode = arr.CheckErrorCode();
                if (errorCode!=null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A23), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    });//正向有功总最大需量
                }

                arr = hexMessageList.GetRange(13 + i * 7, 4);

                 errorCode = arr.CheckErrorCode();
                if (errorCode != null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A17), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    });//正向有功总最大需量
                }
            }
            return values;
        }
        public AnalysisBaseDto<decimal> GenerateFinalResult(List<string> data,string dataType, string filedDesc = "")
        {
            AnalysisBaseDto<decimal> dto = new AnalysisBaseDto<decimal>();

            var errorCodeInfo = data[2].CheckErrorCode();
            if (errorCodeInfo != null)
            {
                dto.ValidData = false;
                dto.ErrorCodeMsg= errorCodeInfo.Item2;
            }
            decimal.TryParse(data[2], out decimal value);
            dto.DataValue = value;
            dto.MeterType= MeterTypeEnum.Ammeter;
            //TODO:最大需量发生时间
            errorCodeInfo = data[3].CheckErrorCode(); 
            if (data[3].Length != 8 && errorCodeInfo != null)
            {
                dto.ValidData = false;
                dto.ErrorCodeMsg = errorCodeInfo.Item2;
            }
            else
            {
               string timeSpan =  $"{DateTime.Now.Year}-{data[3].Substring(0, 2)}-{data[3].Substring(2, 2)} {data[3].Substring(4, 2)}:{data[3].Substring(6, 2)}:00";
         
                //TODO:时间标
                if (!DateTime.TryParse(timeSpan, out DateTime dataTime))
                    dto.ValidData = false;
                dto.TimeSpan = dataTime;
            }
            if (DateTime.Now.Month.Equals(1) && dto.TimeSpan.HasValue)//如果为1月份，则日期减去1年
            {
                dto.TimeSpan= dto.TimeSpan.Value.AddYears(-1);
            }

            dto.FiledDesc = "上月（上一结算日）正向有功最大需量及发生时间";
            dto.FiledName = dataType.GetDataFieldByGatherDataType() ?? string.Empty;
            return dto;
        }


    }
}
